Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## edu.emory.mathcs.backport.java.util.concurrent
Class ConcurrentLinkedQueue

    java.lang.Object
      java.util.AbstractCollection
          edu.emory.mathcs.backport.java.util.AbstractCollection
              edu.emory.mathcs.backport.java.util.AbstractQueue
                  edu.emory.mathcs.backport.java.util.concurrent.ConcurrentLinkedQueue

All Implemented Interfaces:
  java.util.Collection, Queue, java.io.Serializable

public class ConcurrentLinkedQueue
extends AbstractQueue
implements Queue, java.io.Serializable

An unbounded thread-safe queue based on linked nodes. This queue orders elements FIFO (first-in-first-out). The head of the queue is that element that has been on the queue the longest time. The tail of the queue is that element that has been on the queue the shortest time. New elements are inserted at the tail of the queue, and the queue retrieval operations obtain elements at the head of the queue. A `ConcurrentLinkedQueue` is an appropriate choice when many threads will share access to a common collection. This queue does not permit `null` elements.

This implementation employs an efficient "wait-free" algorithm based on one described in Simple, Fast, and Practical Non-Blocking and Blocking Concurrent Queue Algorithms by Maged M. Michael and Michael L. Scott.

Beware that, unlike in most collections, the `size` method is NOT a constant-time operation. Because of the asynchronous nature of these queues, determining the current number of elements requires a traversal of the elements.

This class and its iterator implement all of the optional methods of the `Collection` and `Iterator` interfaces.

Memory consistency effects: As with other concurrent collections, actions in a thread prior to placing an object into a happen-before actions subsequent to the access or removal of that element from the in another thread.

This class is a member of the Java Collections Framework.

Since:
  1.5
Author:
  Doug Lea
See Also:
  Serialized Form

Constructor Summary
`ConcurrentLinkedQueue()` Creates a `ConcurrentLinkedQueue` that is initially empty.
`ConcurrentLinkedQueue(java.util.Collection c)` Creates a `ConcurrentLinkedQueue` initially containing the elements of the given collection, added in traversal order of the collection's iterator.

Method Summary
`boolean` | `add(java.lang.Object e)` Inserts the specified element at the tail of this queue.
`boolean` | `contains(java.lang.Object o)` Returns `true` if this queue contains the specified element.
`boolean` | `isEmpty()` Returns `true` if this queue contains no elements.
`java.util.Iterator` | `iterator()` Returns an iterator over the elements in this queue in proper sequence.
`boolean` | `offer(java.lang.Object e)` Inserts the specified element at the tail of this queue.
`java.lang.Object` | `peek()` Retrieves, but does not remove, the head of this queue, or returns `null` if this queue is empty.
`java.lang.Object` | `poll()` Retrieves and removes the head of this queue, or returns `null` if this queue is empty.
`boolean` | `remove(java.lang.Object o)` Removes a single instance of the specified element from this queue, if it is present.
`int` | `size()` Returns the number of elements in this queue.

Methods inherited from class edu.emory.mathcs.backport.java.util.AbstractQueue
`addAll, clear, element, remove`

Methods inherited from class edu.emory.mathcs.backport.java.util.AbstractCollection
`toArray, toArray`

Methods inherited from class java.util.AbstractCollection
`containsAll, removeAll, retainAll, toString`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Methods inherited from interface edu.emory.mathcs.backport.java.util.Queue
`element, remove`

Methods inherited from interface java.util.Collection
`addAll, clear, containsAll, equals, hashCode, removeAll, retainAll, toArray, toArray`

Constructor Detail

### ConcurrentLinkedQueue

    public ConcurrentLinkedQueue()

  Creates a `ConcurrentLinkedQueue` that is initially empty.

### ConcurrentLinkedQueue

    public ConcurrentLinkedQueue(java.util.Collection c)

  Creates a `ConcurrentLinkedQueue` initially containing the elements of the given collection, added in traversal order of the collection's iterator.

Parameters:
  `c` - the collection of elements to initially contain
Throws:
  `java.lang.NullPointerException` - if the specified collection or any of its elements are null

Method Detail

### add

    public boolean add(java.lang.Object e)

  Inserts the specified element at the tail of this queue.

  Specified by:
    `add` in interface `Queue`
  Overrides:
    `add` in class `AbstractQueue`
  Parameters:
    `e` - the element to add
  Returns:
    `true` (as specified by `Collection.add(java.lang.Object)`)
  Throws:
    `java.lang.NullPointerException` - if the specified element is null

### offer

    public boolean offer(java.lang.Object e)

  Inserts the specified element at the tail of this queue.

  Specified by:
    `offer` in interface `Queue`
  Parameters:
    `e` - the element to add
  Returns:
    `true` (as specified by `Queue.offer(java.lang.Object)`)
  Throws:
    `java.lang.NullPointerException` - if the specified element is null

### poll

    public java.lang.Object poll()

  Description copied from interface: `Queue`
  Retrieves and removes the head of this queue, or returns `null` if this queue is empty.

  Specified by:
    `poll` in interface `Queue`
  Returns:
    the head of this queue, or `null` if this queue is empty

### peek

    public java.lang.Object peek()

  Description copied from interface: `Queue`
  Retrieves, but does not remove, the head of this queue, or returns `null` if this queue is empty.

  Specified by:
    `peek` in interface `Queue`
  Returns:
    the head of this queue, or `null` if this queue is empty

### isEmpty

    public boolean isEmpty()

  Returns `true` if this queue contains no elements.

  Specified by:
    `isEmpty` in interface `java.util.Collection`
  Returns:
    `true` if this queue contains no elements

### size

    public int size()

  Returns the number of elements in this queue. If this queue contains more than `Integer.MAX_VALUE` elements, returns `Integer.MAX_VALUE`.

  Beware that, unlike in most collections, this method is NOT a constant-time operation. Because of the asynchronous nature of these queues, determining the current number of elements requires an O(n) traversal.

  Specified by:
    `size` in interface `java.util.Collection`
  Returns:
    the number of elements in this queue

### contains

    public boolean contains(java.lang.Object o)

  Returns `true` if this queue contains the specified element. More formally, returns `true` if and only if this queue contains at least one element `e` such that `o.equals(e)`.

  Specified by:
    `contains` in interface `java.util.Collection`
  Parameters:
    `o` - object to be checked for containment in this queue
  Returns:
    `true` if this queue contains the specified element

### remove

    public boolean remove(java.lang.Object o)

  Removes a single instance of the specified element from this queue, if it is present. More formally, removes an element `e` such that `o.equals(e)`, if this queue contains one or more such elements. Returns `true` if this queue contained the specified element (or equivalently, if this queue changed as a result of the call).

  Specified by:
    `remove` in interface `java.util.Collection`
  Parameters:
    `o` - element to be removed from this queue, if present
  Returns:
    `true` if this queue changed as a result of the call

### iterator

    public java.util.Iterator iterator()

  Returns an iterator over the elements in this queue in proper sequence. The returned iterator is a "weakly consistent" iterator that will never throw `ConcurrentModificationException`, and guarantees to traverse elements as they existed upon construction of the iterator, and may (but is not guaranteed to) reflect any modifications subsequent to construction.

  Specified by:
    `iterator` in interface `java.util.Collection`
  Returns:
    an iterator over the elements in this queue in proper sequence

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD